<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;miniz_oxide-0.4.4&#x2F;src&#x2F;inflate&#x2F;stream.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>stream.rs - source</title><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../../storage.js"></script><script src="../../../crates.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../../miniz_oxide/index.html'><div class='logo-container rust-logo'><img src='../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
</pre><pre class="rust"><code><span class="doccomment">//! Extra streaming decompression functionality.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! As of now this is mainly inteded for use to build a higher-level wrapper.</span>
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::alloc::boxed::Box</span>;
<span class="kw">use</span> <span class="ident">core</span>::{<span class="ident">cmp</span>, <span class="ident">mem</span>};

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::inflate::core</span>::{<span class="ident">decompress</span>, <span class="ident">inflate_flags</span>, <span class="ident">DecompressorOxide</span>, <span class="ident">TINFL_LZ_DICT_SIZE</span>};
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::inflate::TINFLStatus</span>;
<span class="kw">use</span> <span class="kw">crate</span>::{<span class="ident">DataFormat</span>, <span class="ident">MZError</span>, <span class="ident">MZFlush</span>, <span class="ident">MZResult</span>, <span class="ident">MZStatus</span>, <span class="ident">StreamResult</span>};

<span class="doccomment">/// Tag that determines reset policy of [InflateState](struct.InflateState.html)</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">ResetPolicy</span> {
    <span class="doccomment">/// Performs reset</span>
    <span class="kw">fn</span> <span class="ident">reset</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">state</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">InflateState</span>);
}

<span class="doccomment">/// Resets state, without performing expensive ops (e.g. zeroing buffer)</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Note that not zeroing buffer can lead to security issues when dealing with untrusted input.</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">MinReset</span>;

<span class="kw">impl</span> <span class="ident">ResetPolicy</span> <span class="kw">for</span> <span class="ident">MinReset</span> {
    <span class="kw">fn</span> <span class="ident">reset</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">state</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">InflateState</span>) {
        <span class="ident">state</span>.<span class="ident">decompressor</span>().<span class="ident">init</span>();
        <span class="ident">state</span>.<span class="ident">dict_ofs</span> <span class="op">=</span> <span class="number">0</span>;
        <span class="ident">state</span>.<span class="ident">dict_avail</span> <span class="op">=</span> <span class="number">0</span>;
        <span class="ident">state</span>.<span class="ident">first_call</span> <span class="op">=</span> <span class="bool-val">true</span>;
        <span class="ident">state</span>.<span class="ident">has_flushed</span> <span class="op">=</span> <span class="bool-val">false</span>;
        <span class="ident">state</span>.<span class="ident">last_status</span> <span class="op">=</span> <span class="ident">TINFLStatus::NeedsMoreInput</span>;
    }
}

<span class="doccomment">/// Resets state and zero memory, continuing to use the same data format.</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">ZeroReset</span>;

<span class="kw">impl</span> <span class="ident">ResetPolicy</span> <span class="kw">for</span> <span class="ident">ZeroReset</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">reset</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">state</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">InflateState</span>) {
        <span class="ident">MinReset</span>.<span class="ident">reset</span>(<span class="ident">state</span>);
        <span class="ident">state</span>.<span class="ident">dict</span> <span class="op">=</span> [<span class="number">0</span>; <span class="ident">TINFL_LZ_DICT_SIZE</span>];
    }
}

<span class="doccomment">/// Full reset of the state, including zeroing memory.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Requires to provide new data format.</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">FullReset</span>(<span class="kw">pub</span> <span class="ident">DataFormat</span>);

<span class="kw">impl</span> <span class="ident">ResetPolicy</span> <span class="kw">for</span> <span class="ident">FullReset</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">reset</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">state</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">InflateState</span>) {
        <span class="ident">ZeroReset</span>.<span class="ident">reset</span>(<span class="ident">state</span>);
        <span class="ident">state</span>.<span class="ident">data_format</span> <span class="op">=</span> <span class="self">self</span>.<span class="number">0</span>;
    }
}

<span class="doccomment">/// A struct that compbines a decompressor with extra data for streaming decompression.</span>
<span class="doccomment">///</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">InflateState</span> {
    <span class="doccomment">/// Inner decompressor struct</span>
    <span class="ident">decomp</span>: <span class="ident">DecompressorOxide</span>,

    <span class="doccomment">/// Buffer of input bytes for matches.</span>
    <span class="doccomment">/// TODO: Could probably do this a bit cleaner with some</span>
    <span class="doccomment">/// Cursor-like class.</span>
    <span class="doccomment">/// We may also look into whether we need to keep a buffer here, or just one in the</span>
    <span class="doccomment">/// decompressor struct.</span>
    <span class="ident">dict</span>: [<span class="ident">u8</span>; <span class="ident">TINFL_LZ_DICT_SIZE</span>],
    <span class="doccomment">/// Where in the buffer are we currently at?</span>
    <span class="ident">dict_ofs</span>: <span class="ident">usize</span>,
    <span class="doccomment">/// How many bytes of data to be flushed is there currently in the buffer?</span>
    <span class="ident">dict_avail</span>: <span class="ident">usize</span>,

    <span class="ident">first_call</span>: <span class="ident">bool</span>,
    <span class="ident">has_flushed</span>: <span class="ident">bool</span>,

    <span class="doccomment">/// Whether the input data is wrapped in a zlib header and checksum.</span>
    <span class="doccomment">/// TODO: This should be stored in the decompressor.</span>
    <span class="ident">data_format</span>: <span class="ident">DataFormat</span>,
    <span class="ident">last_status</span>: <span class="ident">TINFLStatus</span>,
}

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">InflateState</span> {
    <span class="kw">fn</span> <span class="ident">default</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="ident">InflateState</span> {
            <span class="ident">decomp</span>: <span class="ident">DecompressorOxide::default</span>(),
            <span class="ident">dict</span>: [<span class="number">0</span>; <span class="ident">TINFL_LZ_DICT_SIZE</span>],
            <span class="ident">dict_ofs</span>: <span class="number">0</span>,
            <span class="ident">dict_avail</span>: <span class="number">0</span>,
            <span class="ident">first_call</span>: <span class="bool-val">true</span>,
            <span class="ident">has_flushed</span>: <span class="bool-val">false</span>,
            <span class="ident">data_format</span>: <span class="ident">DataFormat::Raw</span>,
            <span class="ident">last_status</span>: <span class="ident">TINFLStatus::NeedsMoreInput</span>,
        }
    }
}
<span class="kw">impl</span> <span class="ident">InflateState</span> {
    <span class="doccomment">/// Create a new state.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Note that this struct is quite large due to internal buffers, and as such storing it on</span>
    <span class="doccomment">/// the stack is not recommended.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Parameters</span>
    <span class="doccomment">/// `data_format`: Determines whether the compressed data is assumed to wrapped with zlib</span>
    <span class="doccomment">/// metadata.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">data_format</span>: <span class="ident">DataFormat</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">InflateState</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">b</span> <span class="op">=</span> <span class="ident">InflateState::default</span>();
        <span class="ident">b</span>.<span class="ident">data_format</span> <span class="op">=</span> <span class="ident">data_format</span>;
        <span class="ident">b</span>
    }

    <span class="doccomment">/// Create a new state on the heap.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Parameters</span>
    <span class="doccomment">/// `data_format`: Determines whether the compressed data is assumed to wrapped with zlib</span>
    <span class="doccomment">/// metadata.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new_boxed</span>(<span class="ident">data_format</span>: <span class="ident">DataFormat</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Box</span><span class="op">&lt;</span><span class="ident">InflateState</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">b</span>: <span class="ident">Box</span><span class="op">&lt;</span><span class="ident">InflateState</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">Box::default</span>();
        <span class="ident">b</span>.<span class="ident">data_format</span> <span class="op">=</span> <span class="ident">data_format</span>;
        <span class="ident">b</span>
    }

    <span class="doccomment">/// Access the innner decompressor.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decompressor</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">DecompressorOxide</span> {
        <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>.<span class="ident">decomp</span>
    }

    <span class="doccomment">/// Return the status of the last call to `inflate` with this `InflateState`.</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">last_status</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">TINFLStatus</span> {
        <span class="self">self</span>.<span class="ident">last_status</span>
    }

    <span class="doccomment">/// Create a new state using miniz/zlib style window bits parameter.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The decompressor does not support different window sizes. As such,</span>
    <span class="doccomment">/// any positive (&gt;0) value will set the zlib header flag, while a negative one</span>
    <span class="doccomment">/// will not.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new_boxed_with_window_bits</span>(<span class="ident">window_bits</span>: <span class="ident">i32</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Box</span><span class="op">&lt;</span><span class="ident">InflateState</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">b</span>: <span class="ident">Box</span><span class="op">&lt;</span><span class="ident">InflateState</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">Box::default</span>();
        <span class="ident">b</span>.<span class="ident">data_format</span> <span class="op">=</span> <span class="ident">DataFormat::from_window_bits</span>(<span class="ident">window_bits</span>);
        <span class="ident">b</span>
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="doccomment">/// Reset the decompressor without re-allocating memory, using the given</span>
    <span class="doccomment">/// data format.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">reset</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">data_format</span>: <span class="ident">DataFormat</span>) {
        <span class="self">self</span>.<span class="ident">reset_as</span>(<span class="ident">FullReset</span>(<span class="ident">data_format</span>));
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="doccomment">/// Resets the state according to specified policy.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">reset_as</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">ResetPolicy</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">policy</span>: <span class="ident">T</span>) {
        <span class="ident">policy</span>.<span class="ident">reset</span>(<span class="self">self</span>)
    }
}

<span class="doccomment">/// Try to decompress from `input` to `output` with the given `InflateState`</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Errors</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Returns `MZError::Buf` If the size of the `output` slice is empty or no progress was made due to</span>
<span class="doccomment">/// lack of expected input data or called after the decompression was</span>
<span class="doccomment">/// finished without MZFlush::Finish.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Returns `MZError::Param` if the compressor parameters are set wrong.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">inflate</span>(
    <span class="ident">state</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">InflateState</span>,
    <span class="ident">input</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
    <span class="ident">output</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">u8</span>],
    <span class="ident">flush</span>: <span class="ident">MZFlush</span>,
) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">StreamResult</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">bytes_consumed</span> <span class="op">=</span> <span class="number">0</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">bytes_written</span> <span class="op">=</span> <span class="number">0</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">next_in</span> <span class="op">=</span> <span class="ident">input</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">next_out</span> <span class="op">=</span> <span class="ident">output</span>;

    <span class="kw">if</span> <span class="ident">flush</span> <span class="op">=</span><span class="op">=</span> <span class="ident">MZFlush::Full</span> {
        <span class="kw">return</span> <span class="ident">StreamResult::error</span>(<span class="ident">MZError::Stream</span>);
    }

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">decomp_flags</span> <span class="op">=</span> <span class="ident">inflate_flags::TINFL_FLAG_COMPUTE_ADLER32</span>;
    <span class="kw">if</span> <span class="ident">state</span>.<span class="ident">data_format</span> <span class="op">=</span><span class="op">=</span> <span class="ident">DataFormat::Zlib</span> {
        <span class="ident">decomp_flags</span> <span class="op">|</span><span class="op">=</span> <span class="ident">inflate_flags::TINFL_FLAG_PARSE_ZLIB_HEADER</span>;
    }

    <span class="kw">let</span> <span class="ident">first_call</span> <span class="op">=</span> <span class="ident">state</span>.<span class="ident">first_call</span>;
    <span class="ident">state</span>.<span class="ident">first_call</span> <span class="op">=</span> <span class="bool-val">false</span>;
    <span class="kw">if</span> (<span class="ident">state</span>.<span class="ident">last_status</span> <span class="kw">as</span> <span class="ident">i32</span>) <span class="op">&lt;</span> <span class="number">0</span> {
        <span class="kw">return</span> <span class="ident">StreamResult::error</span>(<span class="ident">MZError::Data</span>);
    }

    <span class="kw">if</span> <span class="ident">state</span>.<span class="ident">has_flushed</span> <span class="op">&amp;&amp;</span> (<span class="ident">flush</span> <span class="op">!</span><span class="op">=</span> <span class="ident">MZFlush::Finish</span>) {
        <span class="kw">return</span> <span class="ident">StreamResult::error</span>(<span class="ident">MZError::Stream</span>);
    }
    <span class="ident">state</span>.<span class="ident">has_flushed</span> <span class="op">|</span><span class="op">=</span> <span class="ident">flush</span> <span class="op">=</span><span class="op">=</span> <span class="ident">MZFlush::Finish</span>;

    <span class="kw">if</span> (<span class="ident">flush</span> <span class="op">=</span><span class="op">=</span> <span class="ident">MZFlush::Finish</span>) <span class="op">&amp;&amp;</span> <span class="ident">first_call</span> {
        <span class="ident">decomp_flags</span> <span class="op">|</span><span class="op">=</span> <span class="ident">inflate_flags::TINFL_FLAG_USING_NON_WRAPPING_OUTPUT_BUF</span>;

        <span class="kw">let</span> <span class="ident">status</span> <span class="op">=</span> <span class="ident">decompress</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">state</span>.<span class="ident">decomp</span>, <span class="ident">next_in</span>, <span class="ident">next_out</span>, <span class="number">0</span>, <span class="ident">decomp_flags</span>);
        <span class="kw">let</span> <span class="ident">in_bytes</span> <span class="op">=</span> <span class="ident">status</span>.<span class="number">1</span>;
        <span class="kw">let</span> <span class="ident">out_bytes</span> <span class="op">=</span> <span class="ident">status</span>.<span class="number">2</span>;
        <span class="kw">let</span> <span class="ident">status</span> <span class="op">=</span> <span class="ident">status</span>.<span class="number">0</span>;

        <span class="ident">state</span>.<span class="ident">last_status</span> <span class="op">=</span> <span class="ident">status</span>;

        <span class="ident">bytes_consumed</span> <span class="op">+</span><span class="op">=</span> <span class="ident">in_bytes</span>;
        <span class="ident">bytes_written</span> <span class="op">+</span><span class="op">=</span> <span class="ident">out_bytes</span>;

        <span class="kw">let</span> <span class="ident">ret_status</span> <span class="op">=</span> {
            <span class="kw">if</span> (<span class="ident">status</span> <span class="kw">as</span> <span class="ident">i32</span>) <span class="op">&lt;</span> <span class="number">0</span> {
                <span class="prelude-val">Err</span>(<span class="ident">MZError::Data</span>)
            } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">status</span> <span class="op">!</span><span class="op">=</span> <span class="ident">TINFLStatus::Done</span> {
                <span class="ident">state</span>.<span class="ident">last_status</span> <span class="op">=</span> <span class="ident">TINFLStatus::Failed</span>;
                <span class="prelude-val">Err</span>(<span class="ident">MZError::Buf</span>)
            } <span class="kw">else</span> {
                <span class="prelude-val">Ok</span>(<span class="ident">MZStatus::StreamEnd</span>)
            }
        };
        <span class="kw">return</span> <span class="ident">StreamResult</span> {
            <span class="ident">bytes_consumed</span>,
            <span class="ident">bytes_written</span>,
            <span class="ident">status</span>: <span class="ident">ret_status</span>,
        };
    }

    <span class="kw">if</span> <span class="ident">flush</span> <span class="op">!</span><span class="op">=</span> <span class="ident">MZFlush::Finish</span> {
        <span class="ident">decomp_flags</span> <span class="op">|</span><span class="op">=</span> <span class="ident">inflate_flags::TINFL_FLAG_HAS_MORE_INPUT</span>;
    }

    <span class="kw">if</span> <span class="ident">state</span>.<span class="ident">dict_avail</span> <span class="op">!</span><span class="op">=</span> <span class="number">0</span> {
        <span class="ident">bytes_written</span> <span class="op">+</span><span class="op">=</span> <span class="ident">push_dict_out</span>(<span class="ident">state</span>, <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">next_out</span>);
        <span class="kw">return</span> <span class="ident">StreamResult</span> {
            <span class="ident">bytes_consumed</span>,
            <span class="ident">bytes_written</span>,
            <span class="ident">status</span>: <span class="prelude-val">Ok</span>(
                <span class="kw">if</span> (<span class="ident">state</span>.<span class="ident">last_status</span> <span class="op">=</span><span class="op">=</span> <span class="ident">TINFLStatus::Done</span>) <span class="op">&amp;&amp;</span> (<span class="ident">state</span>.<span class="ident">dict_avail</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span>) {
                    <span class="ident">MZStatus::StreamEnd</span>
                } <span class="kw">else</span> {
                    <span class="ident">MZStatus::Ok</span>
                },
            ),
        };
    }

    <span class="kw">let</span> <span class="ident">status</span> <span class="op">=</span> <span class="ident">inflate_loop</span>(
        <span class="ident">state</span>,
        <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">next_in</span>,
        <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">next_out</span>,
        <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">bytes_consumed</span>,
        <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">bytes_written</span>,
        <span class="ident">decomp_flags</span>,
        <span class="ident">flush</span>,
    );
    <span class="ident">StreamResult</span> {
        <span class="ident">bytes_consumed</span>,
        <span class="ident">bytes_written</span>,
        <span class="ident">status</span>,
    }
}

<span class="kw">fn</span> <span class="ident">inflate_loop</span>(
    <span class="ident">state</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">InflateState</span>,
    <span class="ident">next_in</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
    <span class="ident">next_out</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">u8</span>],
    <span class="ident">total_in</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">usize</span>,
    <span class="ident">total_out</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">usize</span>,
    <span class="ident">decomp_flags</span>: <span class="ident">u32</span>,
    <span class="ident">flush</span>: <span class="ident">MZFlush</span>,
) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">MZResult</span> {
    <span class="kw">let</span> <span class="ident">orig_in_len</span> <span class="op">=</span> <span class="ident">next_in</span>.<span class="ident">len</span>();
    <span class="kw">loop</span> {
        <span class="kw">let</span> <span class="ident">status</span> <span class="op">=</span> <span class="ident">decompress</span>(
            <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">state</span>.<span class="ident">decomp</span>,
            <span class="kw-2">*</span><span class="ident">next_in</span>,
            <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">state</span>.<span class="ident">dict</span>,
            <span class="ident">state</span>.<span class="ident">dict_ofs</span>,
            <span class="ident">decomp_flags</span>,
        );

        <span class="kw">let</span> <span class="ident">in_bytes</span> <span class="op">=</span> <span class="ident">status</span>.<span class="number">1</span>;
        <span class="kw">let</span> <span class="ident">out_bytes</span> <span class="op">=</span> <span class="ident">status</span>.<span class="number">2</span>;
        <span class="kw">let</span> <span class="ident">status</span> <span class="op">=</span> <span class="ident">status</span>.<span class="number">0</span>;

        <span class="ident">state</span>.<span class="ident">last_status</span> <span class="op">=</span> <span class="ident">status</span>;

        <span class="kw-2">*</span><span class="ident">next_in</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">next_in</span>[<span class="ident">in_bytes</span>..];
        <span class="kw-2">*</span><span class="ident">total_in</span> <span class="op">+</span><span class="op">=</span> <span class="ident">in_bytes</span>;

        <span class="ident">state</span>.<span class="ident">dict_avail</span> <span class="op">=</span> <span class="ident">out_bytes</span>;
        <span class="kw-2">*</span><span class="ident">total_out</span> <span class="op">+</span><span class="op">=</span> <span class="ident">push_dict_out</span>(<span class="ident">state</span>, <span class="ident">next_out</span>);

        <span class="comment">// The stream was corrupted, and decompression failed.</span>
        <span class="kw">if</span> (<span class="ident">status</span> <span class="kw">as</span> <span class="ident">i32</span>) <span class="op">&lt;</span> <span class="number">0</span> {
            <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">MZError::Data</span>);
        }

        <span class="comment">// The decompressor has flushed all it&#39;s data and is waiting for more input, but</span>
        <span class="comment">// there was no more input provided.</span>
        <span class="kw">if</span> (<span class="ident">status</span> <span class="op">=</span><span class="op">=</span> <span class="ident">TINFLStatus::NeedsMoreInput</span>) <span class="op">&amp;&amp;</span> <span class="ident">orig_in_len</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span> {
            <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">MZError::Buf</span>);
        }

        <span class="kw">if</span> <span class="ident">flush</span> <span class="op">=</span><span class="op">=</span> <span class="ident">MZFlush::Finish</span> {
            <span class="kw">if</span> <span class="ident">status</span> <span class="op">=</span><span class="op">=</span> <span class="ident">TINFLStatus::Done</span> {
                <span class="comment">// There is not enough space in the output buffer to flush the remaining</span>
                <span class="comment">// decompressed data in the internal buffer.</span>
                <span class="kw">return</span> <span class="kw">if</span> <span class="ident">state</span>.<span class="ident">dict_avail</span> <span class="op">!</span><span class="op">=</span> <span class="number">0</span> {
                    <span class="prelude-val">Err</span>(<span class="ident">MZError::Buf</span>)
                } <span class="kw">else</span> {
                    <span class="prelude-val">Ok</span>(<span class="ident">MZStatus::StreamEnd</span>)
                };
            <span class="comment">// No more space in the output buffer, but we&#39;re not done.</span>
            } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">next_out</span>.<span class="ident">is_empty</span>() {
                <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">MZError::Buf</span>);
            }
        } <span class="kw">else</span> {
            <span class="comment">// We&#39;re not expected to finish, so it&#39;s fine if we can&#39;t flush everything yet.</span>
            <span class="kw">let</span> <span class="ident">empty_buf</span> <span class="op">=</span> <span class="ident">next_in</span>.<span class="ident">is_empty</span>() <span class="op">|</span><span class="op">|</span> <span class="ident">next_out</span>.<span class="ident">is_empty</span>();
            <span class="kw">if</span> (<span class="ident">status</span> <span class="op">=</span><span class="op">=</span> <span class="ident">TINFLStatus::Done</span>) <span class="op">|</span><span class="op">|</span> <span class="ident">empty_buf</span> <span class="op">|</span><span class="op">|</span> (<span class="ident">state</span>.<span class="ident">dict_avail</span> <span class="op">!</span><span class="op">=</span> <span class="number">0</span>) {
                <span class="kw">return</span> <span class="kw">if</span> (<span class="ident">status</span> <span class="op">=</span><span class="op">=</span> <span class="ident">TINFLStatus::Done</span>) <span class="op">&amp;&amp;</span> (<span class="ident">state</span>.<span class="ident">dict_avail</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span>) {
                    <span class="comment">// No more data left, we&#39;re done.</span>
                    <span class="prelude-val">Ok</span>(<span class="ident">MZStatus::StreamEnd</span>)
                } <span class="kw">else</span> {
                    <span class="comment">// Ok for now, still waiting for more input data or output space.</span>
                    <span class="prelude-val">Ok</span>(<span class="ident">MZStatus::Ok</span>)
                };
            }
        }
    }
}

<span class="kw">fn</span> <span class="ident">push_dict_out</span>(<span class="ident">state</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">InflateState</span>, <span class="ident">next_out</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">u8</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
    <span class="kw">let</span> <span class="ident">n</span> <span class="op">=</span> <span class="ident">cmp::min</span>(<span class="ident">state</span>.<span class="ident">dict_avail</span> <span class="kw">as</span> <span class="ident">usize</span>, <span class="ident">next_out</span>.<span class="ident">len</span>());
    (<span class="ident">next_out</span>[..<span class="ident">n</span>]).<span class="ident">copy_from_slice</span>(<span class="kw-2">&amp;</span><span class="ident">state</span>.<span class="ident">dict</span>[<span class="ident">state</span>.<span class="ident">dict_ofs</span>..<span class="ident">state</span>.<span class="ident">dict_ofs</span> <span class="op">+</span> <span class="ident">n</span>]);
    <span class="kw-2">*</span><span class="ident">next_out</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">mem::replace</span>(<span class="ident">next_out</span>, <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [])[<span class="ident">n</span>..];
    <span class="ident">state</span>.<span class="ident">dict_avail</span> <span class="op">-</span><span class="op">=</span> <span class="ident">n</span>;
    <span class="ident">state</span>.<span class="ident">dict_ofs</span> <span class="op">=</span> (<span class="ident">state</span>.<span class="ident">dict_ofs</span> <span class="op">+</span> (<span class="ident">n</span>)) <span class="op">&amp;</span> (<span class="ident">TINFL_LZ_DICT_SIZE</span> <span class="op">-</span> <span class="number">1</span>);
    <span class="ident">n</span>
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">test</span> {
    <span class="kw">use</span> <span class="kw">super</span>::{<span class="ident">inflate</span>, <span class="ident">InflateState</span>};
    <span class="kw">use</span> <span class="kw">crate</span>::{<span class="ident">DataFormat</span>, <span class="ident">MZFlush</span>, <span class="ident">MZStatus</span>};
    <span class="kw">use</span> <span class="ident">std::vec</span>;

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_state</span>() {
        <span class="kw">let</span> <span class="ident">encoded</span> <span class="op">=</span> [
            <span class="number">120u8</span>, <span class="number">156</span>, <span class="number">243</span>, <span class="number">72</span>, <span class="number">205</span>, <span class="number">201</span>, <span class="number">201</span>, <span class="number">215</span>, <span class="number">81</span>, <span class="number">168</span>, <span class="number">202</span>, <span class="number">201</span>, <span class="number">76</span>, <span class="number">82</span>, <span class="number">4</span>, <span class="number">0</span>, <span class="number">27</span>, <span class="number">101</span>, <span class="number">4</span>,
            <span class="number">19</span>,
        ];
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">out</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="number">0</span>; <span class="number">50</span>];
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">state</span> <span class="op">=</span> <span class="ident">InflateState::new_boxed</span>(<span class="ident">DataFormat::Zlib</span>);
        <span class="kw">let</span> <span class="ident">res</span> <span class="op">=</span> <span class="ident">inflate</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">state</span>, <span class="kw-2">&amp;</span><span class="ident">encoded</span>, <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">out</span>, <span class="ident">MZFlush::Finish</span>);
        <span class="kw">let</span> <span class="ident">status</span> <span class="op">=</span> <span class="ident">res</span>.<span class="ident">status</span>.<span class="ident">expect</span>(<span class="string">&quot;Failed to decompress!&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">status</span>, <span class="ident">MZStatus::StreamEnd</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">out</span>[..<span class="ident">res</span>.<span class="ident">bytes_written</span> <span class="kw">as</span> <span class="ident">usize</span>], <span class="string">b&quot;Hello, zlib!&quot;</span>[..]);
        <span class="macro">assert_eq!</span>(<span class="ident">res</span>.<span class="ident">bytes_consumed</span>, <span class="ident">encoded</span>.<span class="ident">len</span>());

        <span class="ident">state</span>.<span class="ident">reset_as</span>(<span class="ident"><span class="kw">super</span>::ZeroReset</span>);
        <span class="ident">out</span>.<span class="ident">iter_mut</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">x</span><span class="op">|</span> <span class="kw-2">*</span><span class="ident">x</span> <span class="op">=</span> <span class="number">0</span>).<span class="ident">count</span>();
        <span class="kw">let</span> <span class="ident">res</span> <span class="op">=</span> <span class="ident">inflate</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">state</span>, <span class="kw-2">&amp;</span><span class="ident">encoded</span>, <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">out</span>, <span class="ident">MZFlush::Finish</span>);
        <span class="kw">let</span> <span class="ident">status</span> <span class="op">=</span> <span class="ident">res</span>.<span class="ident">status</span>.<span class="ident">expect</span>(<span class="string">&quot;Failed to decompress!&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">status</span>, <span class="ident">MZStatus::StreamEnd</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">out</span>[..<span class="ident">res</span>.<span class="ident">bytes_written</span> <span class="kw">as</span> <span class="ident">usize</span>], <span class="string">b&quot;Hello, zlib!&quot;</span>[..]);
        <span class="macro">assert_eq!</span>(<span class="ident">res</span>.<span class="ident">bytes_consumed</span>, <span class="ident">encoded</span>.<span class="ident">len</span>());

        <span class="ident">state</span>.<span class="ident">reset_as</span>(<span class="ident"><span class="kw">super</span>::MinReset</span>);
        <span class="ident">out</span>.<span class="ident">iter_mut</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">x</span><span class="op">|</span> <span class="kw-2">*</span><span class="ident">x</span> <span class="op">=</span> <span class="number">0</span>).<span class="ident">count</span>();
        <span class="kw">let</span> <span class="ident">res</span> <span class="op">=</span> <span class="ident">inflate</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">state</span>, <span class="kw-2">&amp;</span><span class="ident">encoded</span>, <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">out</span>, <span class="ident">MZFlush::Finish</span>);
        <span class="kw">let</span> <span class="ident">status</span> <span class="op">=</span> <span class="ident">res</span>.<span class="ident">status</span>.<span class="ident">expect</span>(<span class="string">&quot;Failed to decompress!&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">status</span>, <span class="ident">MZStatus::StreamEnd</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">out</span>[..<span class="ident">res</span>.<span class="ident">bytes_written</span> <span class="kw">as</span> <span class="ident">usize</span>], <span class="string">b&quot;Hello, zlib!&quot;</span>[..]);
        <span class="macro">assert_eq!</span>(<span class="ident">res</span>.<span class="ident">bytes_consumed</span>, <span class="ident">encoded</span>.<span class="ident">len</span>());
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="miniz_oxide" data-search-index-js="../../../search-index.js" data-search-js="../../../search.js"></div>
    <script src="../../../main.js"></script><script src="../../../source-script.js"></script><script src="../../../source-files.js"></script>
</body></html>